

module flash_test_top
(
	input       I_clk       ,//50MHz
	input       I_rst_n     ,//KEY1
	output      O_led       ,
	output      O_flash_ck  ,
	output      O_flash_cs_n,
	inout       IO_flash_do ,
	output      IO_flash_di 
);

//===========================================
wire        clk_pll;

// ahb reg 
wire [31:0] haddr_reg;
wire [31:0] hrdata_reg;
wire       	hreadyin_reg;
wire       	hreadyout_reg;
wire [1:0] 	hresp_reg;
wire       	hsel_reg;
wire [1:0] 	htrans_reg;
wire       	hwrite_reg;
wire [31:0] hwdata_reg;

wire        right_o;

//==============================================
assign O_led = ~right_o;

//==============================================
Gowin_PLLVR Gowin_PLLVR_inst
(
    .clkout(clk_pll), //output clkout
    .clkin (I_clk  )  //input clkin
);

//==================================================
//SPI Nor Flash Control
flash_test flash_test_inst      
(
    .clk          (clk_pll      ),//I_clk
    .rst_n        (I_rst_n      ),
	.right_o      (right_o      ),
    .haddr_reg    (haddr_reg    ), //ahb reg mode
 	.hrdata_reg   (hrdata_reg   ),
 	.hreadyin_reg (hreadyin_reg ),
 	.hreadyout_reg(hreadyout_reg),
 	.hresp_reg    (hresp_reg    ),
 	.hsel_reg     (hsel_reg     ),
 	.htrans_reg   (htrans_reg   ),
 	.hwdata_reg   (hwdata_reg   ),
 	.hwrite_reg   (hwrite_reg   )
);   

//===================================================
//SPI Nor Flash Controller
SPI_Nor_Flash_Interface_Top SPI_Nor_Flash_Interface_Top_inst
(
    .I_hclk         (clk_pll      ), //I_clk
	.I_hresetn      (I_rst_n      ),
    .I_haddr_reg    (haddr_reg    ),
 	.O_hrdata_reg   (hrdata_reg   ),
 	.I_hreadyin_reg (hreadyin_reg ),
 	.O_hreadyout_reg(hreadyout_reg),
 	.O_hresp_reg    (hresp_reg    ),
 	.I_hsel_reg     (hsel_reg     ),
 	.I_htrans_reg   (htrans_reg   ),
 	.I_hwdata_reg   (hwdata_reg   ),
 	.I_hwrite_reg   (hwrite_reg   ),
    .I_spi_clock    (clk_pll      ), //input I_spi_clock
    .I_spi_rstn     (I_rst_n      ), //input I_spi_rstn
    .O_flash_ck     (O_flash_ck   ),
	.O_flash_cs_n   (O_flash_cs_n ),
	.IO_flash_do    (IO_flash_do  ),
	.IO_flash_di    (IO_flash_di  )
);

endmodule