
quit -sim

vlib work  

#mapping work library to current directory
#vmap [-help] [-c] [-del] [<logical_name>] [<path>]
vmap work  

#compile all .v files to work library
#-work <path>       Specify library WORK
#-vlog01compat      Ensure compatibility with Std 1364-2001
#-incr              Enable incremental compilation
#"rtl/*.v"          rtl directory all .v files, support relative path, need to add ""
#vlog

vlog -novopt "../../project/src/spi_nor_flash_interface/spi_nor_flash_interface.vo"

vlog -novopt "../../project/src/flash_test.v"

#testbench
vlog -novopt "../../tb/tb.v"

vlog -novopt  \
+incdir+../../tb/flash_model/ \
../../tb/flash_model/spi_flash.v

vlog -novopt "../../tb/prim_sim.v"

#complie all .vhd files
#-work <path>       Specify library WORK
#-93                Enable support for VHDL 1076-1993
#-2002              Enable support for VHDL 1076-2002
#vcom

#simulate testbench top file
#-L <libname>                     Search library for design units instantiated from Verilog and for VHDL default component binding
#+nowarn<CODE | Number>           Disable specified warning message  (Example: +nowarnTFMPC)                      
#-t [1|10|100]fs|ps|ns|us|ms|sec  Time resolution limit VHDL default: resolution setting from .ini file) 
#                                 (Verilog default: minimum time_precision in the design)
#-novopt                          Force incremental mode (pre-6.0 behavior)

vsim +nowarnTFMPC -L work -novopt -l tb.log work.tb 

#generate wave log format(WLF)......
log -r /*

#open wave window
view wave

#add simulation singals
onerror {resume}
quietly WaveActivateNextPane {} 0    
add wave -noupdate -divider {driver_inst output}
add wave -noupdate                    /tb/rst_n
add wave -noupdate                    /tb/clk

add wave -noupdate -divider {flash_top_inst output}
add wave -noupdate                    /tb/right_o

add wave -noupdate -divider {spi signals}
add wave -noupdate                    /tb/spi_clk_o
add wave -noupdate                    /tb/spi_cs_n_o 
add wave -noupdate                    /tb/spi_so_io 
add wave -noupdate                    /tb/spi_si_io 

add wave -noupdate -divider {test signals} 
add wave -position insertpoint sim:/tb/flash_test_inst/*

add wave -noupdate -divider {end signal}

TreeUpdate [SetDefaultTree]
WaveRestoreCursors {{Cursor 1} {912366093 ps} 0}
configure wave -namecolwidth 150
configure wave -valuecolwidth 100
update
WaveRestoreZoom {891247063 ps} {925431255 ps}

#set run time
run  -all




